(function (root, factory) {
  if (typeof define === 'function' && define.amd)
    define(['exports', './kotlin-kotlin-stdlib-js-ir.js'], factory);
  else if (typeof exports === 'object')
    factory(module.exports, require('./kotlin-kotlin-stdlib-js-ir.js'));
  else {
    if (typeof this['kotlin-kotlin-stdlib-js-ir'] === 'undefined') {
      throw new Error("Error loading module 'kotlin-codepoints-parent-kotlin-codepoints'. Its dependency 'kotlin-kotlin-stdlib-js-ir' was not found. Please, check whether 'kotlin-kotlin-stdlib-js-ir' is loaded prior to 'kotlin-codepoints-parent-kotlin-codepoints'.");
    }
    root['kotlin-codepoints-parent-kotlin-codepoints'] = factory(typeof this['kotlin-codepoints-parent-kotlin-codepoints'] === 'undefined' ? {} : this['kotlin-codepoints-parent-kotlin-codepoints'], this['kotlin-kotlin-stdlib-js-ir']);
  }
}(this, function (_, kotlin_kotlin) {
  'use strict';
  //region block: imports
  var protoOf = kotlin_kotlin.$_$.u;
  var numberToChar = kotlin_kotlin.$_$.r;
  var objectMeta = kotlin_kotlin.$_$.t;
  var VOID = kotlin_kotlin.$_$.e1;
  var setMetadataFor = kotlin_kotlin.$_$.v;
  var Unit_getInstance = kotlin_kotlin.$_$.h;
  //endregion
  //region block: pre-declaration
  setMetadataFor(CodePoints, 'CodePoints', objectMeta);
  //endregion
  function CodePoints() {
    CodePoints_instance = this;
    this.t3_1 = 65536;
    this.u3_1 = 1114111;
    this.v3_1 = 55296;
    this.w3_1 = 56320;
    this.x3_1 = -56613888;
    this.y3_1 = 55232;
  }
  protoOf(CodePoints).z3 = function (codePoint) {
    return (codePoint >>> 16 | 0) === 0;
  };
  protoOf(CodePoints).a4 = function (codePoint) {
    return numberToChar((codePoint >>> 10 | 0) + 55232 | 0);
  };
  protoOf(CodePoints).b4 = function (codePoint) {
    return numberToChar((codePoint & 1023) + 56320 | 0);
  };
  var CodePoints_instance;
  function CodePoints_getInstance() {
    if (CodePoints_instance == null)
      new CodePoints();
    return CodePoints_instance;
  }
  function appendCodePoint(_this__u8e3s4, codePoint) {
    var tmp$ret$0;
    // Inline function 'kotlin.apply' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'de.cketti.codepoints.appendCodePoint.<anonymous>' call
    if (CodePoints_getInstance().z3(codePoint)) {
      _this__u8e3s4.d1(numberToChar(codePoint));
    } else {
      _this__u8e3s4.d1(CodePoints_getInstance().a4(codePoint));
      _this__u8e3s4.d1(CodePoints_getInstance().b4(codePoint));
    }
    tmp$ret$0 = _this__u8e3s4;
    return tmp$ret$0;
  }
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = appendCodePoint;
  //endregion
  return _;
}));

//# sourceMappingURL=kotlin-codepoints-parent-kotlin-codepoints.js.map
