(function (root, factory) {
  if (typeof define === 'function' && define.amd)
    define(['exports', './kotlin-kotlin-stdlib-js-ir.js', './kotlin-codepoints-parent-kotlin-codepoints.js'], factory);
  else if (typeof exports === 'object')
    factory(module.exports, require('./kotlin-kotlin-stdlib-js-ir.js'), require('./kotlin-codepoints-parent-kotlin-codepoints.js'));
  else {
    if (typeof this['kotlin-kotlin-stdlib-js-ir'] === 'undefined') {
      throw new Error("Error loading module 'khangul'. Its dependency 'kotlin-kotlin-stdlib-js-ir' was not found. Please, check whether 'kotlin-kotlin-stdlib-js-ir' is loaded prior to 'khangul'.");
    }
    if (typeof this['kotlin-codepoints-parent-kotlin-codepoints'] === 'undefined') {
      throw new Error("Error loading module 'khangul'. Its dependency 'kotlin-codepoints-parent-kotlin-codepoints' was not found. Please, check whether 'kotlin-codepoints-parent-kotlin-codepoints' is loaded prior to 'khangul'.");
    }
    root.khangul = factory(typeof khangul === 'undefined' ? {} : khangul, this['kotlin-kotlin-stdlib-js-ir'], this['kotlin-codepoints-parent-kotlin-codepoints']);
  }
}(this, function (_, kotlin_kotlin, kotlin_kotlin_codepoints_parent_kotlin_codepoints) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var THROW_ISE = kotlin_kotlin.$_$.d1;
  var Unit_getInstance = kotlin_kotlin.$_$.h;
  var Enum = kotlin_kotlin.$_$.c1;
  var protoOf = kotlin_kotlin.$_$.u;
  var defineProp = kotlin_kotlin.$_$.p;
  var classMeta = kotlin_kotlin.$_$.o;
  var VOID = kotlin_kotlin.$_$.e1;
  var setMetadataFor = kotlin_kotlin.$_$.v;
  var charSequenceLength = kotlin_kotlin.$_$.n;
  var charSequenceGet = kotlin_kotlin.$_$.m;
  var Char__toInt_impl_vasixd = kotlin_kotlin.$_$.f;
  var dropLast = kotlin_kotlin.$_$.y;
  var toString = kotlin_kotlin.$_$.g;
  var _Char___init__impl__6a9atx = kotlin_kotlin.$_$.e;
  var Char = kotlin_kotlin.$_$.b1;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.b;
  var copyToArray = kotlin_kotlin.$_$.i;
  var split = kotlin_kotlin.$_$.a1;
  var charArrayOf = kotlin_kotlin.$_$.l;
  var toString_0 = kotlin_kotlin.$_$.w;
  var IllegalArgumentException_init_$Create$ = kotlin_kotlin.$_$.d;
  var indexOf = kotlin_kotlin.$_$.j;
  var numberRangeToNumber = kotlin_kotlin.$_$.q;
  var numberToInt = kotlin_kotlin.$_$.s;
  var primitiveArrayConcat = kotlin_kotlin.$_$.a;
  var objectMeta = kotlin_kotlin.$_$.t;
  var until = kotlin_kotlin.$_$.x;
  var slice = kotlin_kotlin.$_$.z;
  var StringBuilder_init_$Create$ = kotlin_kotlin.$_$.c;
  var appendCodePoint = kotlin_kotlin_codepoints_parent_kotlin_codepoints.$_$.a;
  var toIntArray = kotlin_kotlin.$_$.k;
  //endregion
  //region block: pre-declaration
  setMetadataFor(RemovePolicy, 'RemovePolicy', classMeta, Enum);
  setMetadataFor(HangulContext, 'HangulContext', classMeta);
  setMetadataFor(Symbol, 'Symbol', classMeta);
  setMetadataFor(HangulProcessor, 'HangulProcessor', objectMeta);
  //endregion
  var RemovePolicy_DEFAULT_instance;
  var RemovePolicy_REFORMAT_ON_DELETE_instance;
  function values() {
    return [RemovePolicy_DEFAULT_getInstance(), RemovePolicy_REFORMAT_ON_DELETE_getInstance()];
  }
  function valueOf(value) {
    switch (value) {
      case 'DEFAULT':
        return RemovePolicy_DEFAULT_getInstance();
      case 'REFORMAT_ON_DELETE':
        return RemovePolicy_REFORMAT_ON_DELETE_getInstance();
      default:
        RemovePolicy_initEntries();
        THROW_ISE();
        break;
    }
  }
  var RemovePolicy_entriesInitialized;
  function RemovePolicy_initEntries() {
    if (RemovePolicy_entriesInitialized)
      return Unit_getInstance();
    RemovePolicy_entriesInitialized = true;
    RemovePolicy_DEFAULT_instance = new RemovePolicy('DEFAULT', 0);
    RemovePolicy_REFORMAT_ON_DELETE_instance = new RemovePolicy('REFORMAT_ON_DELETE', 1);
  }
  function RemovePolicy(name, ordinal) {
    Enum.call(this, name, ordinal);
  }
  defineProp(protoOf(RemovePolicy), 'name', protoOf(RemovePolicy).z2);
  defineProp(protoOf(RemovePolicy), 'ordinal', protoOf(RemovePolicy).a3);
  function insertAtCaret($this, value) {
    var selectionStart = getSelectionStart($this);
    var selectionEnd = getSelectionEnd($this);
    var tmp = $this;
    var tmp$ret$1;
    // Inline function 'kotlin.text.substring' call
    var tmp0_substring = $this.f4_1;
    var tmp$ret$0;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$0 = tmp0_substring;
    tmp$ret$1 = tmp$ret$0.substring(0, selectionStart);
    var tmp_0 = tmp$ret$1 + value;
    var tmp$ret$3;
    // Inline function 'kotlin.text.substring' call
    var tmp1_substring = $this.f4_1;
    var tmp$ret$2;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$2 = tmp1_substring;
    tmp$ret$3 = tmp$ret$2.substring(selectionEnd);
    tmp.f4_1 = tmp_0 + tmp$ret$3;
    $this.g4_1 = $this.f4_1.length;
  }
  function deleteAtCaret($this, count, to) {
    var selectionStart = getSelectionStart($this);
    var selectionEnd = getSelectionEnd($this);
    var contentLength = $this.f4_1.length;
    var tmp$ret$0;
    // Inline function 'kotlin.math.min' call
    tmp$ret$0 = Math.min(count, selectionStart);
    var deleteFrom = tmp$ret$0;
    var deleteTo = (selectionEnd + to | 0) > contentLength ? contentLength - selectionEnd | 0 : to;
    var tmp$ret$2;
    // Inline function 'kotlin.text.substring' call
    var tmp0_substring = $this.f4_1;
    var tmp1_substring = selectionStart - deleteFrom | 0;
    var tmp2_substring = selectionEnd + deleteTo | 0;
    var tmp$ret$1;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$1 = tmp0_substring;
    tmp$ret$2 = tmp$ret$1.substring(tmp1_substring, tmp2_substring);
    var deleted = tmp$ret$2;
    var tmp = $this;
    var tmp$ret$4;
    // Inline function 'kotlin.text.substring' call
    var tmp3_substring = $this.f4_1;
    var tmp4_substring = selectionStart - deleteFrom | 0;
    var tmp$ret$3;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$3 = tmp3_substring;
    tmp$ret$4 = tmp$ret$3.substring(0, tmp4_substring);
    var tmp_0 = tmp$ret$4;
    var tmp$ret$6;
    // Inline function 'kotlin.text.substring' call
    var tmp5_substring = $this.f4_1;
    var tmp6_substring = selectionEnd + deleteTo | 0;
    var tmp$ret$5;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$5 = tmp5_substring;
    tmp$ret$6 = tmp$ret$5.substring(tmp6_substring);
    tmp.f4_1 = tmp_0 + tmp$ret$6;
    setCaretPosition($this, selectionStart - deleteFrom | 0);
    return deleted;
  }
  function deleteAtCaret$default($this, count, to, $super) {
    to = to === VOID ? 0 : to;
    return deleteAtCaret($this, count, to);
  }
  function setCaretPosition($this, position) {
    $this.g4_1 = position;
  }
  function getSelectionEnd($this) {
    return $this.g4_1;
  }
  function getSelectionStart($this) {
    return $this.g4_1;
  }
  function HangulContext(initialPhrase, removePolicy) {
    initialPhrase = initialPhrase === VOID ? '' : initialPhrase;
    removePolicy = removePolicy === VOID ? RemovePolicy_DEFAULT_getInstance() : removePolicy;
    this.e4_1 = removePolicy;
    this.f4_1 = initialPhrase;
    this.g4_1 = initialPhrase.length;
  }
  protoOf(HangulContext).clear = function () {
    this.f4_1 = '';
    this.g4_1 = 0;
  };
  protoOf(HangulContext).appendLetter = function (letter) {
    insertAtCaret(this, letter);
    var deleted = deleteAtCaret$default(this, 2);
    insertAtCaret(this, this.composeHangul(deleted));
  };
  protoOf(HangulContext).appendLetters = function (letters) {
    // Inline function 'kotlin.collections.forEach' call
    var indexedObject = letters;
    var inductionVariable = 0;
    var last = indexedObject.length;
    while (inductionVariable < last) {
      var element = indexedObject[inductionVariable];
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'HangulContext.appendLetters.<anonymous>' call
      this.appendLetter(element);
    }
  };
  protoOf(HangulContext).removeLastLetter = function () {
    var deleted = deleteAtCaret$default(this, 1);
    var tmp;
    var tmp$ret$0;
    // Inline function 'kotlin.text.isNotEmpty' call
    var tmp0_isNotEmpty = deleted;
    tmp$ret$0 = charSequenceLength(tmp0_isNotEmpty) > 0;
    if (tmp$ret$0) {
      var tmp$ret$1;
      // Inline function 'kotlin.code' call
      var tmp1__get_code__adl84j = charSequenceGet(deleted, 0);
      tmp$ret$1 = Char__toInt_impl_vasixd(tmp1__get_code__adl84j);
      var containsArg = tmp$ret$1;
      tmp = 56320 <= containsArg ? containsArg <= 57343 : false;
    } else {
      tmp = false;
    }
    if (tmp) {
      deleted = deleteAtCaret$default(this, 1) + deleted;
    }
    var decomposed = this.decomposeHangul(deleted);
    if (decomposed.length > 1) {
      var tmp0_subject = this.e4_1;
      var tmp0 = tmp0_subject.y2_1;
      if (tmp0 === 0) {
        insertAtCaret(this, this.composeHangul(dropLast(decomposed, 1)));
      } else if (tmp0 === 1) {
        // Inline function 'kotlin.text.forEach' call
        var tmp2_forEach = dropLast(decomposed, 1);
        var indexedObject = tmp2_forEach;
        var inductionVariable = 0;
        var last = indexedObject.length;
        while (inductionVariable < last) {
          var element = charSequenceGet(indexedObject, inductionVariable);
          inductionVariable = inductionVariable + 1 | 0;
          // Inline function 'HangulContext.removeLastLetter.<anonymous>' call
          this.appendLetter(toString(element));
        }
      }
    }
  };
  protoOf(HangulContext).composeHangul = function (value) {
    return HangulProcessor_getInstance().x4(value);
  };
  protoOf(HangulContext).y4 = function (value) {
    var tmp = HangulProcessor_getInstance();
    var tmp0_elvis_lhs = value;
    return tmp.z4(tmp0_elvis_lhs == null ? this.f4_1 : tmp0_elvis_lhs);
  };
  protoOf(HangulContext).decomposeHangul = function (value, $super) {
    value = value === VOID ? null : value;
    return this.y4(value);
  };
  protoOf(HangulContext).getValue = function () {
    return this.f4_1;
  };
  function RemovePolicy_DEFAULT_getInstance() {
    RemovePolicy_initEntries();
    return RemovePolicy_DEFAULT_instance;
  }
  function RemovePolicy_REFORMAT_ON_DELETE_getInstance() {
    RemovePolicy_initEntries();
    return RemovePolicy_REFORMAT_ON_DELETE_instance;
  }
  function Symbol(value, compoundOf) {
    compoundOf = compoundOf === VOID ? null : compoundOf;
    this.a5_1 = value;
    this.b5_1 = compoundOf;
  }
  function HangulProcessor() {
    HangulProcessor_instance = this;
    var tmp = this;
    var tmp$ret$2;
    // Inline function 'kotlin.arrayOf' call
    var tmp$ret$1;
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp$ret$0;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$0 = [new Char(_Char___init__impl__6a9atx(12593)), new Char(_Char___init__impl__6a9atx(12594)), new Char(_Char___init__impl__6a9atx(12596)), new Char(_Char___init__impl__6a9atx(12599)), new Char(_Char___init__impl__6a9atx(12600)), new Char(_Char___init__impl__6a9atx(12601)), new Char(_Char___init__impl__6a9atx(12609)), new Char(_Char___init__impl__6a9atx(12610)), new Char(_Char___init__impl__6a9atx(12611)), new Char(_Char___init__impl__6a9atx(12613)), new Char(_Char___init__impl__6a9atx(12614)), new Char(_Char___init__impl__6a9atx(12615)), new Char(_Char___init__impl__6a9atx(12616)), new Char(_Char___init__impl__6a9atx(12617)), new Char(_Char___init__impl__6a9atx(12618)), new Char(_Char___init__impl__6a9atx(12619)), new Char(_Char___init__impl__6a9atx(12620)), new Char(_Char___init__impl__6a9atx(12621)), new Char(_Char___init__impl__6a9atx(12622))];
    tmp$ret$1 = tmp$ret$0;
    tmp$ret$2 = tmp$ret$1;
    tmp.h4_1 = tmp$ret$2;
    var tmp_0 = this;
    var tmp$ret$7;
    // Inline function 'kotlin.collections.toTypedArray' call
    var tmp$ret$6;
    // Inline function 'kotlin.collections.map' call
    var tmp1_map = this.h4_1;
    var tmp$ret$5;
    // Inline function 'kotlin.collections.mapTo' call
    var tmp0_mapTo = ArrayList_init_$Create$(tmp1_map.length);
    var indexedObject = tmp1_map;
    var inductionVariable = 0;
    var last = indexedObject.length;
    while (inductionVariable < last) {
      var item = indexedObject[inductionVariable].c1_1;
      inductionVariable = inductionVariable + 1 | 0;
      var tmp$ret$4;
      // Inline function 'HangulProcessor.initialCodes.<anonymous>' call
      var tmp$ret$3;
      // Inline function 'kotlin.code' call
      tmp$ret$3 = Char__toInt_impl_vasixd(item);
      tmp$ret$4 = tmp$ret$3;
      tmp0_mapTo.e1(tmp$ret$4);
    }
    tmp$ret$5 = tmp0_mapTo;
    tmp$ret$6 = tmp$ret$5;
    var tmp2_toTypedArray = tmp$ret$6;
    tmp$ret$7 = copyToArray(tmp2_toTypedArray);
    tmp_0.i4_1 = tmp$ret$7;
    var tmp_1 = this;
    var tmp$ret$10;
    // Inline function 'kotlin.arrayOf' call
    var tmp0_arrayOf = [new Char(_Char___init__impl__6a9atx(0)), new Char(_Char___init__impl__6a9atx(12593)), new Char(_Char___init__impl__6a9atx(12594)), new Char(_Char___init__impl__6a9atx(12595)), new Char(_Char___init__impl__6a9atx(12596)), new Char(_Char___init__impl__6a9atx(12597)), new Char(_Char___init__impl__6a9atx(12598)), new Char(_Char___init__impl__6a9atx(12599)), new Char(_Char___init__impl__6a9atx(12601)), new Char(_Char___init__impl__6a9atx(12602)), new Char(_Char___init__impl__6a9atx(12603)), new Char(_Char___init__impl__6a9atx(12604)), new Char(_Char___init__impl__6a9atx(12605)), new Char(_Char___init__impl__6a9atx(12606)), new Char(_Char___init__impl__6a9atx(12607)), new Char(_Char___init__impl__6a9atx(12608)), new Char(_Char___init__impl__6a9atx(12609)), new Char(_Char___init__impl__6a9atx(12610)), new Char(_Char___init__impl__6a9atx(12612)), new Char(_Char___init__impl__6a9atx(12613)), new Char(_Char___init__impl__6a9atx(12614)), new Char(_Char___init__impl__6a9atx(12615)), new Char(_Char___init__impl__6a9atx(12616)), new Char(_Char___init__impl__6a9atx(12618)), new Char(_Char___init__impl__6a9atx(12619)), new Char(_Char___init__impl__6a9atx(12620)), new Char(_Char___init__impl__6a9atx(12621)), new Char(_Char___init__impl__6a9atx(12622))];
    var tmp$ret$9;
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp$ret$8;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$8 = tmp0_arrayOf;
    tmp$ret$9 = tmp$ret$8;
    tmp$ret$10 = tmp$ret$9;
    tmp_1.j4_1 = tmp$ret$10;
    this.k4_1 = split(',\u3131,\u3132,\u3131\u3145,\u3134,\u3134\u3148,\u3134\u314E,\u3137,\u3139,\u3139\u3131,\u3139\u3141,\u3139\u3142,\u3139\u3145,\u3139\u314C,\u3139\u314D,\u3139\u314E,\u3141,\u3142,\u3142\u3145,\u3145,\u3146,\u3147,\u3148,\u314A,\u314B,\u314C,\u314D,\u314E', [',']);
    var tmp_2 = this;
    var tmp$ret$15;
    // Inline function 'kotlin.collections.toTypedArray' call
    var tmp$ret$14;
    // Inline function 'kotlin.collections.map' call
    var tmp1_map_0 = this.j4_1;
    var tmp$ret$13;
    // Inline function 'kotlin.collections.mapTo' call
    var tmp0_mapTo_0 = ArrayList_init_$Create$(tmp1_map_0.length);
    var indexedObject_0 = tmp1_map_0;
    var inductionVariable_0 = 0;
    var last_0 = indexedObject_0.length;
    while (inductionVariable_0 < last_0) {
      var item_0 = indexedObject_0[inductionVariable_0].c1_1;
      inductionVariable_0 = inductionVariable_0 + 1 | 0;
      var tmp$ret$12;
      // Inline function 'HangulProcessor.finaleCodes.<anonymous>' call
      var tmp$ret$11;
      // Inline function 'kotlin.code' call
      tmp$ret$11 = Char__toInt_impl_vasixd(item_0);
      tmp$ret$12 = tmp$ret$11;
      tmp0_mapTo_0.e1(tmp$ret$12);
    }
    tmp$ret$13 = tmp0_mapTo_0;
    tmp$ret$14 = tmp$ret$13;
    var tmp2_toTypedArray_0 = tmp$ret$14;
    tmp$ret$15 = copyToArray(tmp2_toTypedArray_0);
    tmp_2.l4_1 = tmp$ret$15;
    var tmp_3 = this;
    var tmp$ret$18;
    // Inline function 'kotlin.arrayOf' call
    var tmp0_arrayOf_0 = [new Symbol(_Char___init__impl__6a9atx(12623)), new Symbol(_Char___init__impl__6a9atx(12624)), new Symbol(_Char___init__impl__6a9atx(12625)), new Symbol(_Char___init__impl__6a9atx(12626)), new Symbol(_Char___init__impl__6a9atx(12627)), new Symbol(_Char___init__impl__6a9atx(12628)), new Symbol(_Char___init__impl__6a9atx(12629)), new Symbol(_Char___init__impl__6a9atx(12630)), new Symbol(_Char___init__impl__6a9atx(12631)), new Symbol(_Char___init__impl__6a9atx(12632), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12631), _Char___init__impl__6a9atx(12623)]))), new Symbol(_Char___init__impl__6a9atx(12633), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12631), _Char___init__impl__6a9atx(12624)]))), new Symbol(_Char___init__impl__6a9atx(12634), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12631), _Char___init__impl__6a9atx(12643)]))), new Symbol(_Char___init__impl__6a9atx(12635)), new Symbol(_Char___init__impl__6a9atx(12636)), new Symbol(_Char___init__impl__6a9atx(12637), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12636), _Char___init__impl__6a9atx(12627)]))), new Symbol(_Char___init__impl__6a9atx(12638), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12636), _Char___init__impl__6a9atx(12628)]))), new Symbol(_Char___init__impl__6a9atx(12639), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12636), _Char___init__impl__6a9atx(12643)]))), new Symbol(_Char___init__impl__6a9atx(12640)), new Symbol(_Char___init__impl__6a9atx(12641)), new Symbol(_Char___init__impl__6a9atx(12642), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12641), _Char___init__impl__6a9atx(12643)]))), new Symbol(_Char___init__impl__6a9atx(12643))];
    var tmp$ret$17;
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp$ret$16;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$16 = tmp0_arrayOf_0;
    tmp$ret$17 = tmp$ret$16;
    tmp$ret$18 = tmp$ret$17;
    tmp_3.m4_1 = tmp$ret$18;
    var tmp_4 = this;
    var tmp$ret$23;
    // Inline function 'kotlin.collections.toTypedArray' call
    var tmp$ret$22;
    // Inline function 'kotlin.collections.map' call
    var tmp1_map_1 = this.m4_1;
    var tmp$ret$21;
    // Inline function 'kotlin.collections.mapTo' call
    var tmp0_mapTo_1 = ArrayList_init_$Create$(tmp1_map_1.length);
    var indexedObject_1 = tmp1_map_1;
    var inductionVariable_1 = 0;
    var last_1 = indexedObject_1.length;
    while (inductionVariable_1 < last_1) {
      var item_1 = indexedObject_1[inductionVariable_1];
      inductionVariable_1 = inductionVariable_1 + 1 | 0;
      var tmp$ret$20;
      // Inline function 'HangulProcessor.medialCodes.<anonymous>' call
      var tmp$ret$19;
      // Inline function 'kotlin.code' call
      var tmp0__get_code__88qj9g = item_1.a5_1;
      tmp$ret$19 = Char__toInt_impl_vasixd(tmp0__get_code__88qj9g);
      tmp$ret$20 = tmp$ret$19;
      tmp0_mapTo_1.e1(tmp$ret$20);
    }
    tmp$ret$21 = tmp0_mapTo_1;
    tmp$ret$22 = tmp$ret$21;
    var tmp2_toTypedArray_1 = tmp$ret$22;
    tmp$ret$23 = copyToArray(tmp2_toTypedArray_1);
    tmp_4.n4_1 = tmp$ret$23;
    var tmp_5 = this;
    var tmp$ret$26;
    // Inline function 'kotlin.arrayOf' call
    var tmp$ret$25;
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp$ret$24;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$24 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 800, 801, 820, 0, 0, 1304, 1305, 1320, 0, 0, 1820];
    tmp$ret$25 = tmp$ret$24;
    tmp$ret$26 = tmp$ret$25;
    tmp_5.o4_1 = tmp$ret$26;
    var tmp_6 = this;
    var tmp$ret$29;
    // Inline function 'kotlin.arrayOf' call
    var tmp$ret$28;
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp$ret$27;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$27 = [0, 0, 0, 119, 0, 422, 427, 0, 0, 801, 816, 817, 819, 825, 826, 827, 0, 0, 1719, 0, 1919];
    tmp$ret$28 = tmp$ret$27;
    tmp$ret$29 = tmp$ret$28;
    tmp_6.p4_1 = tmp$ret$29;
    this.q4_1 = 44032;
    this.r4_1 = 12623;
    this.s4_1 = 21;
    this.t4_1 = 588;
    this.u4_1 = this.l4_1.length;
    this.v4_1 = this.i4_1.length;
    this.w4_1 = imul(imul(this.v4_1, 21), this.u4_1);
    // Inline function 'kotlin.require' call
    var tmp0_require = this.v4_1 === 19;
    // Inline function 'kotlin.contracts.contract' call
    if (!tmp0_require) {
      var tmp$ret$30;
      // Inline function 'HangulProcessor.<anonymous>' call
      tmp$ret$30 = 'Initial count must be equal to 19';
      var message = tmp$ret$30;
      throw IllegalArgumentException_init_$Create$(toString_0(message));
    }
    // Inline function 'kotlin.require' call
    var tmp1_require = this.u4_1 === 28;
    // Inline function 'kotlin.contracts.contract' call
    if (!tmp1_require) {
      var tmp$ret$31;
      // Inline function 'HangulProcessor.<anonymous>' call
      tmp$ret$31 = 'Finale count must be equal to 28';
      var message_0 = tmp$ret$31;
      throw IllegalArgumentException_init_$Create$(toString_0(message_0));
    }
  }
  protoOf(HangulProcessor).x4 = function (input) {
    var tmp$ret$0;
    // Inline function 'kotlin.text.isEmpty' call
    tmp$ret$0 = charSequenceLength(input) === 0;
    if (tmp$ret$0)
      return '';
    var tmp$ret$1;
    // Inline function 'kotlin.code' call
    var tmp0__get_code__88qj9g = charSequenceGet(input, 0);
    tmp$ret$1 = Char__toInt_impl_vasixd(tmp0__get_code__88qj9g);
    var syllableCode = tmp$ret$1;
    var result = fromCharCode(new Int32Array([syllableCode]));
    var inductionVariable = 1;
    var last = input.length;
    if (inductionVariable < last)
      $l$loop_4: do {
        var charIdx = inductionVariable;
        inductionVariable = inductionVariable + 1 | 0;
        var tmp$ret$2;
        // Inline function 'kotlin.code' call
        var tmp1__get_code__adl84j = charSequenceGet(input, charIdx);
        tmp$ret$2 = Char__toInt_impl_vasixd(tmp1__get_code__adl84j);
        var currentCode = tmp$ret$2;
        var initialCode = indexOf(this.i4_1, syllableCode);
        var vowelDiff = currentCode - 12623 | 0;
        if (!(initialCode === -1)) {
          if (0 <= vowelDiff ? vowelDiff < 21 : false) {
            syllableCode = 44032 + imul(imul(initialCode, 21) + vowelDiff | 0, this.u4_1) | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
        }
        var relativeSyllableCode = syllableCode - 44032 | 0;
        var finalConsonant = relativeSyllableCode % this.u4_1 | 0;
        if ((0 <= relativeSyllableCode ? relativeSyllableCode <= 11144 : false) ? finalConsonant === 0 : false) {
          var currentFinale = indexOf(this.l4_1, currentCode);
          if (!(currentFinale === -1)) {
            syllableCode = syllableCode + currentFinale | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
          var mediaVowelBase = (relativeSyllableCode % 588 | 0) / this.u4_1 | 0;
          var doubledMedialVowel = indexOf(this.o4_1, imul(mediaVowelBase, 100) + (currentCode - 12623 | 0) | 0);
          if (doubledMedialVowel > 0) {
            syllableCode = syllableCode + imul(doubledMedialVowel - mediaVowelBase | 0, this.u4_1) | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
        }
        if ((0 <= relativeSyllableCode ? relativeSyllableCode < this.w4_1 : false) ? !(finalConsonant === 0) : false) {
          if (0 <= vowelDiff ? vowelDiff < 21 : false) {
            initialCode = indexOf(this.i4_1, this.l4_1[finalConsonant]);
            if (0 <= initialCode ? initialCode < this.v4_1 : false) {
              result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode - finalConsonant | 0]));
              syllableCode = 44032 + imul(imul(initialCode, 21) + vowelDiff | 0, this.u4_1) | 0;
              result = result + fromCharCode(new Int32Array([syllableCode]));
              continue $l$loop_4;
            }
            if (finalConsonant < this.p4_1.length ? !(this.p4_1[finalConsonant] === 0) : false) {
              var tmp = sliceExclusive(result, numberRangeToNumber(0, result.length));
              var tmp_0 = syllableCode - finalConsonant | 0;
              var tmp$ret$3;
              // Inline function 'kotlin.math.floor' call
              var tmp2_floor = this.p4_1[finalConsonant] / 100.0;
              tmp$ret$3 = Math.floor(tmp2_floor);
              result = tmp + fromCharCode(new Int32Array([tmp_0 + numberToInt(tmp$ret$3) | 0]));
              syllableCode = 44032 + imul(imul(indexOf(this.i4_1, this.l4_1[this.p4_1[finalConsonant] % 100 | 0]), 21) + vowelDiff | 0, this.u4_1) | 0;
              result = result + fromCharCode(new Int32Array([syllableCode]));
              continue $l$loop_4;
            }
          }
          var doubledFinaleConsonant = indexOf(this.p4_1, imul(finalConsonant, 100) + indexOf(this.l4_1, currentCode) | 0);
          if (doubledFinaleConsonant > 0) {
            syllableCode = (syllableCode + doubledFinaleConsonant | 0) - finalConsonant | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
        }
        syllableCode = currentCode;
        result = result + fromCharCode(new Int32Array([currentCode]));
      }
       while (inductionVariable < last);
    return result;
  };
  protoOf(HangulProcessor).z4 = function (input) {
    var result = '';
    var indexedObject = input;
    var inductionVariable = 0;
    var last = indexedObject.length;
    $l$loop: while (inductionVariable < last) {
      var char = charSequenceGet(indexedObject, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      var tmp$ret$0;
      // Inline function 'kotlin.code' call
      tmp$ret$0 = Char__toInt_impl_vasixd(char);
      var syllableIndex = tmp$ret$0 - 44032 | 0;
      if (syllableIndex < 0 ? true : syllableIndex >= this.w4_1) {
        result = result + new Char(char);
        continue $l$loop;
      }
      var tmp$ret$1;
      // Inline function 'kotlin.math.floor' call
      var tmp0_floor = syllableIndex / 588.0;
      tmp$ret$1 = Math.floor(tmp0_floor);
      var initialCode = this.i4_1[numberToInt(tmp$ret$1)];
      var syllable = 12623 + ((syllableIndex % 588 | 0) / this.u4_1 | 0) | 0;
      var finaleCode = this.l4_1[syllableIndex % this.u4_1 | 0];
      var tmp$ret$4;
      $l$block: {
        // Inline function 'kotlin.collections.firstOrNull' call
        var tmp1_firstOrNull = this.m4_1;
        var indexedObject_0 = tmp1_firstOrNull;
        var inductionVariable_0 = 0;
        var last_0 = indexedObject_0.length;
        while (inductionVariable_0 < last_0) {
          var element = indexedObject_0[inductionVariable_0];
          inductionVariable_0 = inductionVariable_0 + 1 | 0;
          var tmp$ret$3;
          // Inline function 'HangulProcessor.decomposeHangul.<anonymous>' call
          var tmp$ret$2;
          // Inline function 'kotlin.code' call
          var tmp0__get_code__88qj9g = element.a5_1;
          tmp$ret$2 = Char__toInt_impl_vasixd(tmp0__get_code__88qj9g);
          tmp$ret$3 = tmp$ret$2 === syllable;
          if (tmp$ret$3) {
            tmp$ret$4 = element;
            break $l$block;
          }
        }
        tmp$ret$4 = null;
      }
      var tmp1_safe_receiver = tmp$ret$4;
      var tmp2_elvis_lhs = tmp1_safe_receiver == null ? null : tmp1_safe_receiver.b5_1;
      var tmp;
      if (tmp2_elvis_lhs == null) {
        var tmp$ret$5;
        // Inline function 'kotlin.intArrayOf' call
        tmp$ret$5 = new Int32Array([syllable]);
        tmp = tmp$ret$5;
      } else {
        tmp = tmp2_elvis_lhs;
      }
      var syllableStructure = tmp;
      result = result + fromCharCode(primitiveArrayConcat([new Int32Array([initialCode]), syllableStructure]));
      if (!(finaleCode === 0)) {
        result = result + this.k4_1.f(syllableIndex % this.u4_1 | 0);
      }
    }
    return result;
  };
  var HangulProcessor_instance;
  function HangulProcessor_getInstance() {
    if (HangulProcessor_instance == null)
      new HangulProcessor();
    return HangulProcessor_instance;
  }
  function sliceExclusive(_this__u8e3s4, range) {
    return slice(_this__u8e3s4, until(range.u_1, range.v_1 - 2 | 0));
  }
  function fromCharCode(codePoints) {
    var builder = StringBuilder_init_$Create$(codePoints.length);
    var indexedObject = codePoints;
    var inductionVariable = 0;
    var last = indexedObject.length;
    while (inductionVariable < last) {
      var codePoint = indexedObject[inductionVariable];
      inductionVariable = inductionVariable + 1 | 0;
      appendCodePoint(builder, codePoint);
    }
    return builder.toString();
  }
  function codePointArray(chars) {
    var tmp$ret$3;
    // Inline function 'kotlin.collections.map' call
    var tmp$ret$2;
    // Inline function 'kotlin.collections.mapTo' call
    var tmp0_mapTo = ArrayList_init_$Create$(chars.length);
    var indexedObject = chars;
    var inductionVariable = 0;
    var last = indexedObject.length;
    while (inductionVariable < last) {
      var item = indexedObject[inductionVariable];
      inductionVariable = inductionVariable + 1 | 0;
      var tmp$ret$1;
      // Inline function 'codePointArray.<anonymous>' call
      var tmp$ret$0;
      // Inline function 'kotlin.code' call
      tmp$ret$0 = Char__toInt_impl_vasixd(item);
      tmp$ret$1 = tmp$ret$0;
      tmp0_mapTo.e1(tmp$ret$1);
    }
    tmp$ret$2 = tmp0_mapTo;
    tmp$ret$3 = tmp$ret$2;
    return toIntArray(tmp$ret$3);
  }
  //region block: exports
  function $jsExportAll$(_) {
    _.RemovePolicy = RemovePolicy;
    _.RemovePolicy.values = values;
    _.RemovePolicy.valueOf = valueOf;
    defineProp(_.RemovePolicy, 'DEFAULT', RemovePolicy_DEFAULT_getInstance);
    defineProp(_.RemovePolicy, 'REFORMAT_ON_DELETE', RemovePolicy_REFORMAT_ON_DELETE_getInstance);
    _.HangulContext = HangulContext;
    _.HangulContext.deleteAtCaret$default = deleteAtCaret$default;
  }
  $jsExportAll$(_);
  //endregion
  return _;
}));

//# sourceMappingURL=khangul.js.map
